<?php
$KTO_VERSION = '1.71';
// wersja 1.71 (11.02.2006)
/*
** 11.02.2006 1.71 - Dodano $total_limit
** 25.01.2006 1.70 - Dodano $show_limit
** 20.01.2005 1.69 - Dodano kontrole wielkosci otwieranych plikow (poniewaz dla
**                   fread wielkosc pliku musi byc > 0 )
** 01.02.2004 1.67 - Dodano $mark_limit - znakowanie na czerowno przydzialow
**                   jesli zostal przekroczony limit ilosci przeslanych danych.
** 29.12.2003 1.66 - Dodano mozliwosc wylaczenia kontroli pingami wywolywanymi
**                   przez skrypt w celu zmniejszenia obciazenia systemu.
**                   Zmienna $ping=0 wlacza kontrole we wspolpracy ze skryptem
**                   kto-daemon uruchamianym z crona
**                   dodano $mailto i $showip
**                   dodano paramert -m dla finger
** 17.11.2003 1.65 - Poprawki wyswietlania ID Tlen i GaduGadu dla dodatkowych
**                   wpisow w pliku /etc/shaper/iplist.X
** 27.08.2003 1.64 - Poprawilem procedure wyswietlajaca widelki w kierunku upload
**                   poniewaz w przypadku gdy revDNS dla numeru IP serwera roznil
**                   sie od domeny prostej to wartosc upload nie byla wyswietlana
** 02.07.2003 1.63 - Zmienilem metode wykrywania nazwy HOSTa na ktorym pracuje
**                   skrypt poniewaz stara metoda odczytu zmiennej HOSTNAME
**                   nie dzialala na MDK 9.1
** 26.06.2003 1.62 - Poprawilem kontrole pingami poniewaz na niektorych
**                   systemach widziane byly aktywne wszystkie numery IP
**		     np. w Mandrake 9.1
**		     Fixed ping controle because this don't work on some
**		     systems (e.g. Mandrake 9.1)
** 16.04.2003 1.61 - Dodalem procedure do konwersji adresow e-mail na ciagi &#
**                   jako zabezpieczenie antyspamowe.
**                   Added email converting procedure to &# strings for spam
**                   protection.
** 06.04.2003 1.60 - Tlumaczenie komentazy na angielski
**                   Translated comments to english
** 23.02.2003 1.55 - Mala kosmetyka.
**                   Small fixes.
** 24.01.2003 1.54 - Dodalem procedure do pingowania numerow ip z innymi
**		     maskami niz /32. Dodalem alternatywna do ping kontrole
**		     aktywnosci userow - badanie czy jest przydzial.
**                   Added ping procedure for users with another masks as /32
**                   Added alternatively control of users activity if ICMP
**                   is blocked by user's side - checking is exists bandwidth
**                   assignment.
** 15.01.2003 1.53 - Zlikwidowalem zmienna $only_ip
**                   Removed $only_ip variable
** 02.01.2003 1.52 - Zlikwidowalem zmienne $serwer_name i $domena
**                   Removed $serwer_name and $domena variables
** 31.12.2002 1.51 - Poprawka wyswietlania GG i tlen dla userow
**                   z indywidualnymi widelkami.
**                   Fixed bug in showing communicators procedure for users
**                   with individual forks.
** 13.12.2002 1.50 - Dodano wyswietlanie szybkosci upload
**                   Added upload bandwidth showing.
** 06.12.2002 1.41 - Poprawka wyswietlania wintalk
**                   Fixed bug in wintalk showing procedure
** 12.11.2002 1.40 - Odczyt numeru GG i ID tlenu z /etc/shaper/iplist.X
**                   Added procedure for reading communicators datas from
**                   /etc/shaper/iplist.X file
** 12.11.2002 1.39 - Poprawka dla altgg zrobiona przez adam1024@go2.pl.
**                   Fixed bug in altgg made by adam1024@go2.pl.
*/

// ustaw dla ktorej konfiguracji shaperd maja byc wyswietlane przydzialy
// which number of shaperd configuration should be used?
$shaperd_counter = 0;

// ustaw jeden dla phpnuke
// 1 - will turn on phpnuke support
$phpn = 0;

// 1 - wlacza test przy pomocy ping
// 0 odczytuje liste aktywnych userow z pliku /tmp/kto.txt
$ping = 0;

// 1 - wlacza MAILTO:
$mailto = 0;

// 1 - wlacza wyswietlanie numerow IP zamiast nazw
$showip = 0;

// 1 - wlacza kolorowanie przydzialow jesli przekroczony limit
$mark_limit = 1;

// 1 - wlacza procentowe wyswietlanie wykorzystanego limitu
$show_limit = 1;

if ($phpn) require("mainfile.php");
$pagetitle = "- Aktywne Komputery";

// wlacz alternatywna kontrole GaduGadu
// 1 - will turn on alternatively control of GaduGadu communicator
$altgg = 0;

// wlacz alternatywna kontrole Tlen
// 1 - will turn on alternatively control of Tlen communicator
$alttlen = 0;

// alternatywna kontrola GaduGadu
// alternatively control of GaduGadu communicator
    if ($altgg)
    {
	if (file_exists("/tmp/gadugadu.txt"))
	{
    	    if (($filesizetmp=filesize("/tmp/gadugadu.txt")) > 0)
	    {
		$fp=fopen("/tmp/gadugadu.txt",'r');
		$raw=fread($fp,$filesizetmp);
		fclose($fp);
	    }
	    $gg = explode("\n", $raw);
	}
	else $altgg = 0;
    }

// alternatywna kontrola Tlen
// alternatively control of Tlen communicator
    if ($alttlen)
    {
	if (file_exists("/tmp/tlen.txt"))
	{
    	    if (($filesizetmp=filesize("/tmp/tlen.txt")) > 0)
	    {
		$fp=fopen("/tmp/tlen.txt",'r');
		$raw=fread($fp,$filesizetmp);
		fclose($fp);
	    }
	    $tlen = explode("\n", $raw);
	}
	else $alttlen = 0;
    }

function Pokaz() {
    global	$user, $cookie, $prefix, $dbi, $user_prefix, $gg, $altgg,
		$tlen, $alttlen, $phpn, $shaperd_counter, $KTO_VERSION,
		$ping, $kto, $mailto, $showip, $limit_path, $mark_limit,
		$show_limit, $user_dnload_limit, $user_upload_limit,
		$default_download_limit, $default_upload_limit, $speed_ext,
		$total_limit;

if ($phpn)
{
    include ("header.php");
    OpenTable();
}

// Zmienne edytowane przez administratora
// Variables edited by administrator

    // ilosc pingow do jednego hosta
    // how many times check single host by ping command
    $ping_times=1;
    
    // czas oczekiwania na wynik pingow - przy duzej ilosci hostow czas trzeba
    // wydluzyc.
    // time of waiting for results of ping command - if a lot of hosts to check
    // should be increased
    $delay=2;

    // nazwa serwera pocztowego
    $mail_name='trzepak.net';

    // plik z wykorzystaniem limitow
    $limit_path='/var/lib/shaper/last.'.$shaperd_counter;
    
    
// koniec zmiennych edytowanych
// end of edited section

    // nazwa serwera
    // server name
    $server_name = explode(".",gethostbyaddr(getenv("SERVER_ADDR")));
    $serwer_name = $server_name[0];
    $domena      = ".".$server_name[1].".".$server_name[2];

    // jesli internet nie pracuje prawidlowo to uzywaj alternatywnej
    // kontroli GG i tlen
    // if internet ling don't work - use alternatively control of communicators
    if (file_exists("/tmp/internet"))
    {
	$fp = fopen("/tmp/internet",'r');
	$internet_status = fread($fp,1);
	fclose($fp);
	if (! $internet_status)
	{
	    $altgg = 1;
	    $alttlen = 1;
	}
    }

    $shaper_config_path='/etc/shaper/shaper.'.$shaperd_counter.'.cfg';
    $shaper_iplist='/etc/shaper/iplist.'.$shaperd_counter;

    if (($filesize=filesize($shaper_config_path)) > 0)
    {
	$fp=fopen($shaper_config_path,'r');
	$shaperraw=fread($fp,$filesize);
	fclose($fp);
    }
    $shapertmp = explode("\n", $shaperraw);
    for ($i=0; $i<count($shapertmp); $i++)
    {
	if ($shapertmp[$i])
	{
	    // ignorujemy komentarze
	    if ($shapertmp[$i][0]!='#')
	    {
		$shaper_param = explode('=',$shapertmp[$i]);
		if ($shaper_param[0]=='default_download_limit') $default_download_limit=$shaper_param[1];
		if ($shaper_param[0]=='default_upload_limit') $default_upload_limit=$shaper_param[1];
		if ($shaper_param[0]=='speed_ext') $speed_ext=$shaper_param[1];
		if ($shaper_param[0]=='total_limit')
		{
		    if (strtolower($shaper_param[1])=="yes" || $shaper_param[1]=="1") $total_limit=1;
		    else $total_limit=0;
		}
	    }
	}
    }

    if (($filesize=filesize($shaper_iplist)) > 0)
    {
	$fp=fopen($shaper_iplist,'r');
	$iplistraw=fread($fp,$filesize);
	fclose($fp);
    }
    $iplisttmp = explode("\n", $iplistraw);
    $j=0;
    $l=0;
    for ($i=0; $i<count($iplisttmp); $i++)
    {
	if ($iplisttmp[$i])
	{
	    // ignorujemy komentarze
	    if ($iplisttmp[$i][0]!='#')
	    {
		$usertmp = explode('=',$iplisttmp[$i]);
	        $usertmp2 = explode('/',$usertmp[0]);
		$usertmp3 = explode(' ',$iplisttmp[$i]);
		$user_dnload_limit[$l] = '';
		$user_upload_limit[$l] = '';
		$fin = 0;
		for($k=2;$k<15;$k++)
		{
		    if ($usertmp3[$k][0]=='"')
		    {
			$users_ggtmp = explode('"',$usertmp3[$k]);
		        $users_tlentmp = explode('"',$usertmp3[$k+1]);
			$fin = 1;
		        break;
		    }
		    else
		    {
			if ($usertmp3[$k][0]!='')
			{
			    if ($k==6)
				if ($usertmp3[$k]!=1) $user_dnload_limit[$l] = $usertmp3[$k];
				else $user_dnload_limit[$l] = '';
			    if ($k==7)
				if ($usertmp3[$k]!=1) $user_upload_limit[$l] = $usertmp3[$k];
				else $user_upload_limit[$l] = '';
//			    echo "1. usertmp3[$k]=$usertmp3[$k]<br>";
			}
		    }
		}
		if (! $fin)
		{
		    $users_ggtmp = "";
		    $users_tlentmp = "";
		}

		// jesli maska inna niz /32 to sprawdzamy zakres
		// if mask is not /32 - checking range
		if ($usertmp2[1])
		{
		    $iprange = pow(2,(32-$usertmp2[1]));
		    $partip = explode('.',$usertmp2[0]);
		    $from_ip = hexdec(sprintf("%02x%02x%02x%02x",$partip[0],$partip[1],$partip[2],$partip[3]));
		    $to_ip = $from_ip + $iprange;
		    for($n=$from_ip; $n<$to_ip; $n++)
		    {
			$to_hex_ip = dechex($n);
		        $to_dec_ip = hexdec(substr($to_hex_ip,0,2)).".";
			$to_dec_ip.= hexdec(substr($to_hex_ip,2,2)).".";
		        $to_dec_ip.= hexdec(substr($to_hex_ip,4,2)).".";
			$to_dec_ip.= hexdec(substr($to_hex_ip,6,2));

	    		$user = explode($domena,gethostbyaddr($to_dec_ip));
	    	        $users[$j] = $user[0];
//	    		$user = gethostbyaddr($to_dec_ip);
//	    	        $users[$j] = $user;
			// dla usera podstawowego wyswietlamy numer GG
			// for main user we show communicators datas
			if ($n == $from_ip)
			{
			    $users_gg[$users[$j]] = $users_ggtmp[1];
		    	    $users_tlen[$users[$j]] = $users_tlentmp[1];
			}
	    		$users_ip[$j++] = $usertmp2[0];
		    }
		}
		else
		{
	    	    $user = explode($domena,gethostbyaddr($usertmp2[0]));
	    	    $users[$j] = $user[0];
//	    	    $user = gethostbyaddr($usertmp2[0]);
//	    	    $users[$j] = $user;
		    $users_gg[$users[$j]] = $users_ggtmp[1];
		    $users_tlen[$users[$j]] = $users_tlentmp[1];
	    	    $users_ip[$j++] = $usertmp2[0];
		}
		$l++;
	    }
	}
    }

    $shaper_filename='/var/lib/shaper/bitrate_user_sh.'.$shaperd_counter.'.old';
    $shaout_filename='/var/lib/shaper/bitrate_user_up.'.$shaperd_counter.'.old';
    if (! $alttlen) $tlen="<a href=\"http://www.tlen.pl/pobierz.html\">Tlen</a>";

// Inicjalizacja generatora liczb losowych
// Initialisation of random generator

    srand((double)microtime()*1000000);
    $rand_id=rand(0,10000);

    Function GaduGadu ($name,$users_gg)
    {
	global  $gg, $altgg;
	
	while (list($id,$val) = each($users_gg))
	{
	    if ($name==$id)
	    {
		if ($val=="") return("");
		else
		{
		    if ($altgg)
		    {
		        $ipt = gethostbyname($name);
			for($n=0;$n<count($gg);$n++)
			    if ($gg[$n] == $ipt) return("GG: $val <img src=\"pics/gg.gif\"> ");
			return("GG: $val <img src=\"pics/gg_off.gif\"> ");
		    }
		    else return("GG: $val <img src=\"http://www.gadu-gadu.pl/users/status.asp?id=$val&styl=1\"> ");
		}
	    }
	}
    }
    Function Tlen ($name,$users_tlen)
    {
	global  $tlen, $alttlen;	
	while (list($id,$val) = each($users_tlen))
	{
	    if ($name==$id)
	    {
		if ($val=="") return("");
		else
		{
		    if ($alttlen)
		    {
			$ipt = gethostbyname($name);
			for($n=0;$n<count($tlen);$n++)
			{
			    if ($tlen[$n] == $ipt) return("Tlen: <a href=\"http://ludzie.tlen.pl/$val/\" target=\"_blank\">$val</a> <img src=\"pics/tlen.gif\"> ");
			}
			return("Tlen: <a href=\"http://ludzie.tlen.pl/$val/\" target=\"_blank\">$val</a> <img src=\"pics/tlen_off.gif\"> ");
		    }
		    else return("Tlen: <a href=\"http://ludzie.tlen.pl/$val/\" target=\"_blank\">$val</a> <img src=\"http://status.tlen.pl/?u=$val&t=1\"> ");
		}
	    }
	}
    }

    Function is_active_ip ($user,$lines,$linesup)
    {
	$ip = gethostbyname($user);
	for ($n=0; $n<count($lines)-1; $n++)
	{
	    $linesipt=explode(' ',$lines[$n]);
	    $linesip=explode('/',$linesipt[0]);
	    if (!strcmp($linesip[0],$ip)) return(1);
	}
	for ($n=0; $n<count($linesup)-1; $n++)
	{
	    $linesipt=explode(' ',$linesup[$n]);
	    $linesip=explode('/',$linesipt[0]);
	    if (!strcmp($linesip[0],$ip)) return(1);
	}
	return(0);
    }

    Function acode ($string)
    {
	for($n=0;$n<strlen($string);$n++)
	    $res .= sprintf("&#%d;",(int)Ord($string[$n]));

	return($res);
    }

    Function find_kto ($user)
    {
	global	$kto;
	
	for ($i=0;$i<count($kto);$i++)
	{
	    if (!strcmp($user,$kto[$i])) return(1);
	}
	return(0);
    }

    Function is_download_limit ($host)
    {
	global	$limit_path;

        if (file_exists($limit_path))
        {
	    if (($filesizetmp=filesize($limit_path)) > 0)
	    {
    		$fp=fopen($limit_path,'r');
    	    	$raw=fread($fp,$filesizetmp);
    		fclose($fp);
	    }
    	    $limit_lines = explode("\n", $raw);

    	    for ($i=0; $i<count($limit_lines); $i++)
	    {
		$limit = explode(" ",$limit_lines[$i]);
		$limit_iptmp = explode("/",$limit[0]);
	        $limit_ip[$i] = $limit_iptmp[0];
	        $limit_dlimit[$i] = $limit[1];
	        $limit_ulimit[$i] = $limit[2];
	        $limit_shaper[$i] = $limit[3];
	        $limit_squid[$i] = $limit[4];
	        $limit_shaout[$i] = $limit[5];

    	        if ($limit_ip[$i] == $host)
	        {
	    	    return($limit_dlimit[$i]);
		}
	    }
	}
	return(-1);
    }

    Function is_upload_limit ($host)
    {
	global	$limit_path;

        if (file_exists($limit_path))
        {
	    if (($filesizetmp=filesize($limit_path)) > 0)
	    {
    		$fp=fopen($limit_path,'r');
    		$raw=fread($fp,$filesizetmp);
    		fclose($fp);
	    }
    	    $limit_lines = explode("\n", $raw);

    	    for ($i=0; $i<count($limit_lines); $i++)
	    {
		$limit = explode(" ",$limit_lines[$i]);
		$limit_iptmp = explode("/",$limit[0]);
	        $limit_ip[$i] = $limit_iptmp[0];
	        $limit_dlimit[$i] = $limit[1];
	        $limit_ulimit[$i] = $limit[2];
	        $limit_shaper[$i] = $limit[3];
	        $limit_squid[$i] = $limit[4];
	        $limit_shaout[$i] = $limit[5];

    	        if ($limit_ip[$i] == $host)
	        {
	    	    return($limit_ulimit[$i]);
		}
	    }
	}
	return(-1);
    }

    Function get_download_limit ($host)
    {
	global	$limit_path, $shaper_config_path, $shaper_iplist, $user_dnload_limit,
		$user_upload_limit, $default_download_limit, $default_upload_limit,
		$speed_ext, $total_limit;

        if (file_exists($limit_path))
        {
	    if (($filesizetmp=filesize($limit_path)) > 0)
	    {
    		$fp=fopen($limit_path,'r');
    		$raw=fread($fp,$filesizetmp);
    		fclose($fp);
	    }
    	    $limit_lines = explode("\n", $raw);

    	    for ($i=0; $i<count($limit_lines); $i++)
	    {
		$limit = explode(" ",$limit_lines[$i]);
		$limit_iptmp = explode("/",$limit[0]);
	        $limit_ip[$i] = $limit_iptmp[0];
	        $limit_dlimit[$i] = $limit[1];
	        $limit_ulimit[$i] = $limit[2];
	        $limit_shaper[$i] = $limit[3];
	        $limit_squid[$i] = $limit[4];
	        $limit_shaout[$i] = $limit[5];
	        $limit_sqout[$i] = $limit[6];

    	        if ($limit_ip[$i] == $host)
	        {
		    $l = 0;
	    	    if ($user_dnload_limit[$i] != '' ) $l = $user_dnload_limit[$i];
		    else if ($default_download_limit != '') $l = $default_download_limit;
                    if ($total_limit)
                    {
                        if ($user_upload_limit[$i] != '' ) $l += $user_upload_limit[$i];
                        else if ($default_upload_limit != '') $l += $default_upload_limit;
                    }
		    if (is_numeric($l) && $l > 1)
		    {
			if (strtolower($speed_ext)=='bit') $mnoznik = 1;
			else if (strtolower($speed_ext)=='kbit') $mnoznik = 1024;
			else if (strtolower($speed_ext)=='mbit') $mnoznik = 1048576;
			if (!$total_limit) return((($limit_shaper[$i]+$limit_squid[$i])/($l*$mnoznik))*100);
			else return((($limit_shaper[$i]+$limit_squid[$i]+$limit_shaout[$i]+$limit_sqout[$i])/($l*$mnoznik))*100);
		    }
		    else
		    {
			return(-1);
		    }
		}
	    }
	}
	return(-1);
    }

    Function get_upload_limit ($host)
    {
	global	$limit_path, $shaper_config_path, $shaper_iplist, $user_dnload_limit,
		$user_upload_limit, $default_download_limit, $default_upload_limit,
		$speed_ext, $total_limit;

        if (file_exists($limit_path))
        {
	    if (($filesizetmp=filesize($limit_path)) > 0)
	    {
    		$fp=fopen($limit_path,'r');
    		$raw=fread($fp,$filesizetmp);
    		fclose($fp);
	    }
    	    $limit_lines = explode("\n", $raw);

    	    for ($i=0; $i<count($limit_lines); $i++)
	    {
		$limit = explode(" ",$limit_lines[$i]);
		$limit_iptmp = explode("/",$limit[0]);
	        $limit_ip[$i] = $limit_iptmp[0];
	        $limit_dlimit[$i] = $limit[1];
	        $limit_ulimit[$i] = $limit[2];
	        $limit_shaper[$i] = $limit[3];
	        $limit_squid[$i] = $limit[4];
	        $limit_shaout[$i] = $limit[5];
	        $limit_sqout[$i] = $limit[6];

    	        if ($limit_ip[$i] == $host)
	        {
		    $l = 0;
	    	    if ($user_upload_limit[$i] != '' ) $l = $user_upload_limit[$i];
		    else if ($default_upload_limit != '') $l = $default_upload_limit;
		    if (is_numeric($l) && $l > 1)
		    {
			if (strtolower($speed_ext)=='bit') $mnoznik = 1;
			else if (strtolower($speed_ext)=='kbit') $mnoznik = 1024;
			else if (strtolower($speed_ext)=='mbit') $mnoznik = 1048576;
			return((($limit_shaout[$i]+$limit_sqout[$i])/($l*$mnoznik))*100);
		    }
		    else
		    {
			return(-1);
		    }
		}
	    }
	}
	return(-1);
    }

    header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");             // Date in the past
    header("Last-Modified: " . gmdate("D, d M Y H:i:s") . "GMT"); // always modified
    header("Cache-Control: no-cache, must-revalidate");           // HTTP/1.1
    header("Pragma: no-cache");                                   // HTTP/1.0

    if ($ping)
    {
        for ($i=0; $i<count($users); $i++)
        {
    	    system("ping -c $ping_times -w 1 $users_ip[$i] | grep icmp_seq > /tmp/ping.$rand_id.$users[$i] &");
	}
        system("sleep $delay");
    }
    else
    {
	if (file_exists("/tmp/kto.txt"))
	{
    	    if (($filesizetmp=filesize("/tmp/kto.txt")) > 0)
	    {
		$fp=fopen("/tmp/kto.txt",'r');
		$raw=fread($fp,$filesizetmp);
		fclose($fp);
	    }
	    $kto = explode("\n", $raw);
	}
    }


    print "<HTML>\n";
    print "<HEAD>\n";
    print "<META HTTP-EQUIV=\"Content-Type: text/html; CHARSET=iso-8859-2\">\n";
    print "<META HTTP-EQUIV=\"Refresh\" CONTENT=\"60; URL=kto.php\">\n";
    print "<TITLE>Kto jest aktywny w sieci</TITLE>\n";
    print "<BODY BGCOLOR=\"#FFFFFF\" TEXT=\"black\" LINK=\"blue\" ";
    print "VLINK=\"blue\" ALINK=\"blue\" BACKGROUND=\"\" TOPMARGIN=\"0\" ";
    print "BORDER=\"0\" LEFTMARGIN=\"0\" MARGINHEIGHT=\"0\" MARGINWIDTH=\"0\">\n";
    print "<FONT COLOR=\"black\">\n";
    print "<CENTER>\n";
    print "<font face=\"Helvetica\" size=\"5\"><B>Komputery aktywne w sieci:</B></FONT>\n";
    print "<BR><BR><BR>\n";
    print "<table width=\"600\">\n";
    print "<tr bgcolor=\"#D1D1D1\">\n";
    print "<td align=\"center\" bgcolor=\"#D1D1D1\" width=\"40\">\n";
    print "<font face=\"Helvetica\" size=\"-1\">\n";
    print "<b>Mail</b>\n";
    print "</font>\n";
    print "</td>\n";
    print "<td align=\"center\" bgcolor=\"#D1D1D1\" width=\"100\">\n";
    print "<font face=\"Helvetica\" size=\"-1\">\n";
    print "<b>Host</b>\n";
    print "</font>\n";
    print "</td>\n";
    print "</td>\n";
    print "<td align=\"center\" bgcolor=\"#D1D1D1\" width=\"100\">\n";
    print "<font face=\"Helvetica\" size=\"-1\">\n";
    print "<b><a href=\"slownik.php#QoS\">QoS</a> Bandwidth [kB/s]</b>\n";
    print "</font>\n";
    print "</td>\n";
    if ($show_limit)
    {
        print "<td align=\"center\" bgcolor=\"#D1D1D1\" width=\"100\">\n";
        print "<font face=\"Helvetica\" size=\"-1\">\n";
	print "<b>Limity<br>[%]</b>\n";
        print "</font>\n";
        print "</td>\n";
    }
    print "<td align=\"center\" bgcolor=\"#D1D1D1\" width=\"450\">\n";
    print "<font face=\"Helvetica\" size=\"-1\">\n";
    print "<b>Komunikator</b>\n";
    print "</font>\n";
    print "</td>\n";
    print "</tr>\n";

    if (file_exists($shaper_filename))
    {
	if (($filesize=filesize($shaper_filename)) > 0)
	{
	    $fp=fopen($shaper_filename,'r');
	    $raw=fread($fp,$filesize);
	    fclose($fp);
	}
    	$lines = explode("\n", $raw);
    }

    if (file_exists($shaout_filename))
    {
	if (($filesizeup=filesize($shaout_filename)) > 0)
	{
    	    $fp=fopen($shaout_filename,'r');
	    $raw=fread($fp,$filesizeup);
    	    fclose($fp);
	}
        $linesup = explode("\n", $raw);
    }

    // kontrola wintalka
    if (file_exists("/tmp/wintalk.tmp"))
    {
	if (($filesizetmp=filesize("/tmp/wintalk.tmp")) > 0)
	{
    	    $fp=fopen("/tmp/wintalk.tmp",'r');
    	    $raw=fread($fp,$filesizetmp);
    	    fclose($fp);
	}
        $linestmp = explode("\n", $raw);
    }

    $findn=0;
    $ilk=0;
    for ($i=0; $i<count($users); $i++)
    {
	$fname="/tmp/ping.".$rand_id.".".$users[$i];
//	Dla static_dnload i statis_upload
//	if (!$ping && (find_kto($users_ip[$i])))
	if ((!$ping && (find_kto($users_ip[$i]) || is_active_ip($users[$i],$lines,$linesup))) || ($ping && (filesize($fname)>10 || is_active_ip($users[$i],$lines,$linesup))))
	{
//	    if (! $showip) $ip = gethostbyname($users[$i].$domena);
	    if (! $showip) $ip = gethostbyname($users[$i]);
	    else $ip = $users_ip[$i];
	    if ($ip == $users[$i]) echo "PHPBUG: gethostbyname returns not ip.<br>";
	    $rate="0.00";
	    for ($n=0; $n<count($lines)-1; $n++)
	    {
		$linesipt=explode(' ',$lines[$n]);
		$linesip=explode('/',$linesipt[0]);
		if (!strcmp($linesip[0],$ip))
		{
		    $ratet=explode(' ',$lines[$n]);
		    if ($ratet[2]=='kbit')
			$rate=$ratet[1]/8;
		    else
		    if ($ratet[2]=='mbit')
			$rate=($ratet[1]*1000)/8;
		    else
		    $rate=$ratet[1]/8000;
		    if ($rate==0)
		    {
			$rate='0.00';
		    }
		    $findn=1;
		}
	    }
	    if ($findn==0) $rate='0.00';
	    
	    $finup=0;
	    for ($n=0; $n<count($linesup)-1; $n++)
	    {
		$linesipt_up=explode(' ',$linesup[$n]);
		$linesip_up=explode('/',$linesipt_up[0]);
//		$ip2 = gethostbyaddr(gethostbyname($linesip_up[0]));
		$ip2 = gethostbyaddr($linesip_up[0]);
		if (!strcmp($linesip_up[0],$ip) || (!$showip && !strcmp($ip2,gethostbyname($ip))))
//		if (!strcmp($linesip_up[0],$ip))
		{
		    $ratet_up=explode(' ',$linesup[$n]);
		    if ($ratet_up[2]=='kbit')
			$rate_up=$ratet_up[1]/8;
		    else
		    if ($ratet_up[2]=='mbit')
			$rate_up=($ratet_up[1]*1000)/8;
		    else
		    $rate_up=$ratet_up[1]/8000;
		    if ($rate_up==0)
		    {
			$rate_up='0.00';
		    }
		    $finup=1;
		}
	    }
	    if ($finup==0) $rate_up='0.00';

	    $wintalk=0;
	    for ($n=0; $n<count($linestmp)-1; $n++)
	    {
		$linesip=explode(' ',$linestmp[$n]);
		if (!strcmp($linesip[4],$ip))
		{
		    $wintalk=$linesip[1];
		}
	    }
	    
    	    print "<tr height=\"25\"><td bgcolor=\"#E1E1E1\" align=\"center\" valign=\"center\"> ";
	    print "<font face=\"Helvetica\" size=\"-1\">";

	    $fp=popen("finger -m $users[$i] 2> /dev/null | grep 'New mail'","r");
	    $ckmail=fgets($fp,4);    
	    pclose($fp);
	    if ($ckmail=='New')
	    {
		print "<IMG SRC=\"$main_url/pics/email.gif\">";
	    }
	    print "</font></td>\n";
	    print "     <td bgcolor=\"#E1E1E1\" align=\"center\" valign=\"center\">";
	    print "<font face=\"Helvetica\" size=\"-1\">";
//	    print "<A HREF=\"mailto:$users[$i]@$mail_name\">$users[$i]</a></font></td>";
	    if ($mailto) print "<A HREF=\"".acode("mailto:$users[$i]@$mail_name")."\">$users[$i]</a></font></td>";
	    else
	    {
		if ($showip) print "$users_ip[$i]</font></td>";
		else print "$users[$i]</font></td>";
	    }
	    print "</font></td>\n";
	    print "     <td bgcolor=\"#E1E1E1\" align=\"center\" valign=\"center\">";
	    if ($mark_limit && is_download_limit($users_ip[$i])>0) printf("<font face=\"Helvetica\" size=\"-1\" color=\"ff0000\">%.1f</font>",$rate);
	    else printf("<font face=\"Helvetica\" size=\"-1\">%.1f",$rate);
	    print "<font face=\"Helvetica\" size=\"-1\">/</font>";
	    if ($mark_limit && is_upload_limit($users_ip[$i])>0) printf("<font face=\"Helvetica\" size=\"-1\" color=\"ff0000\">%.1f</font></td>",$rate_up);
	    else printf("<font face=\"Helvetica\" size=\"-1\">%.1f</font></td>",$rate_up);
	    print "</font></td>\n";
	    if ($show_limit)
	    {
		print "     <td bgcolor=\"#E1E1E1\" align=\"center\" valign=\"center\">";
		$dn = get_download_limit($users_ip[$i]);
	        if ($dn > -1)
		{
		    if ($dn > 80) printf("<font face=\"Helvetica\" size=\"-1\" color=\"ff0000\">%.1f</font>",$dn);
		    else printf("<font face=\"Helvetica\" size=\"-1\">%.1f",$dn);
		}
		else printf("<font face=\"Helvetica\" size=\"-1\">0.0");
		if (!$total_limit)
		{
		    print "<font face=\"Helvetica\" size=\"-1\">/</font>";
		    $dn = get_upload_limit($users_ip[$i]);
	    	    if ($dn > -1)
		    {
			if ($dn > 80) printf("<font face=\"Helvetica\" size=\"-1\" color=\"ff0000\">%.1f</font>",$dn);
		        else printf("<font face=\"Helvetica\" size=\"-1\">%.1f",$dn);
		    }
		    else printf("<font face=\"Helvetica\" size=\"-1\">0.0");
		}
    		print "</font></td>\n";
	    }
    	    print "     <td bgcolor=\"#E1E1E1\" align=\"left\" valign=\"center\">";
	    print "<font face=\"Helvetica\" size=\"-1\">";
	    print GaduGadu($users[$i],$users_gg);
	    print Tlen($users[$i],$users_tlen);
	    if ($wintalk) print "Talk: <img src=\"pics/wtalk.gif\" width=16 height=16 alt=\"WinTalk\">";
	    print "</font></td>";
	    print "</font></td>\n";
	    $ilk++;
	}
    }
    print "</TABLE>\n";
    print "<BR><FONT COLOR=\"black\"><font face=\"Helvetica\" size=\"3\">";
    print "<IMG SRC=\"$main_url/pics/email.gif\"> - oznacza ze jest poczta oczekujaca na koncie.";
    print "</FONT><BR>";
    print "<BR><FONT COLOR=\"black\"><font face=\"Helvetica\" size=\"3\">";
    print "Ilosc komputerow: $ilk</FONT><BR>\n";
    print "<FONT COLOR=\"black\"><font face=\"Helvetica\" size=\"3\">";
    print "Ostatnia aktualizacja: <B>";
    print date("H:i:s");
    print "</B><BR><BR>\n";
    print "(C) 2006 <a href=\"&#109;&#97;&#105;&#108;&#116;&#111;&#58;&#115;&#112;&#57;&#119;&#117;&#110;&#64;&#112;&#111;&#99;&#122;&#116;&#97;&#46;&#111;&#110;&#101;&#116;&#46;&#112;&#108;\">Grzegorz Fitrzyk</a><br>\n";
    print "</FONT><FONT COLOR=\"black\"><font face=\"Helvetica\" size=\"2\">";
    print "kto.php \$VER: ".$KTO_VERSION."<br>";
    print "This script is a part of the <a href=\"http://sp9wun.republika.pl/\">shaper_cbq</a> LAN traffic manager.<br>\n";
    print "</FONT><BR>\n";
    system("rm -f /tmp/ping.$rand_id.* >/dev/null");

    if ($phpn)
    {
	CloseTable();
	include ('footer.php');
    }
}

switch($op) {

    default:
    Pokaz();
    break;
}

?>
